#include <stdlib.h>
#include <string.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
#define YYPREFIX "yy"
#line 25 "parse.y"

#include <sys/queue.h>

#include <ctype.h>
#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdint.h>
#include <string.h>
#include <unistd.h>

#ifndef nitems
#define nitems(_a) (sizeof((_a)) / sizeof((_a)[0]))
#endif

TAILQ_HEAD(files, file)		 files = TAILQ_HEAD_INITIALIZER(files);
static struct file {
	TAILQ_ENTRY(file)	 entry;
	FILE			*stream;
	char			*name;
	size_t			 ungetpos;
	size_t			 ungetsize;
	unsigned char		*ungetbuf;
	int			 eof_reached;
	int			 lineno;
	int			 errors;
} *file, *topfile;
int		 parse(const char *);
struct file	*pushfile(const char *, int);
int		 popfile(void);
int		 yyparse(void);
int		 yylex(void);
int		 yyerror(const char *, ...)
    __attribute__((__format__ (printf, 1, 2)))
    __attribute__((__nonnull__ (1)));
int		 kw_cmp(const void *, const void *);
int		 lookup(char *);
int		 igetc(void);
int		 lgetc(int);
void		 lungetc(int);
int		 findeol(void);

void		 dbg(void);
void		 printq(const char *);

extern int	 nodebug;

static int	 block;
static int	 in_define;
static int	 errors;
static int	 lastline = -1;

typedef struct {
	union {
		char		*string;
	} v;
	int lineno;
} YYSTYPE;

#line 74 "y.tab.c"
#define DEFINE 257
#define ELSE 258
#define END 259
#define ERROR 260
#define FINALLY 261
#define FOR 262
#define IF 263
#define INCLUDE 264
#define PRINTF 265
#define RENDER 266
#define TQFOREACH 267
#define UNSAFE 268
#define URLESCAPE 269
#define STRING 270
#define YYERRCODE 256
const short yylhs[] =
	{                                        -1,
    0,    0,    0,    0,    0,    3,    4,    6,    6,    7,
    7,    8,    5,    5,    9,   10,   10,   10,   10,   13,
   13,   13,   13,   13,   13,   13,   19,   14,   18,   18,
   15,   16,   16,   16,   21,   20,   22,   17,   23,   17,
   11,   24,   12,    1,    1,    2,    2,    2,
};
const short yylen[] =
	{                                         2,
    0,    2,    2,    2,    2,    2,    3,    0,    2,    0,
    2,    1,    3,    4,    4,    0,    2,    2,    2,    4,
    1,    3,    1,    5,    5,    3,    0,    5,    0,    2,
    4,    1,    3,    3,    5,    3,    0,    7,    0,    9,
    3,    0,    5,    2,    1,    1,    2,    2,
};
const short yydefred[] =
	{                                      1,
    0,    5,    0,    8,    0,    2,    3,    4,   16,    6,
    0,    0,    0,    9,    7,    0,    0,   12,    0,   17,
   18,   13,    0,   19,   21,   16,   23,   44,   15,    0,
    0,    0,    0,   27,    0,    0,    0,    0,   14,    0,
   41,   42,    0,    0,    0,    0,   29,    0,    0,   26,
    0,    0,   32,   22,   16,   16,   10,   47,   48,   37,
   31,    0,   20,    0,    0,    0,    0,    0,    0,    0,
   16,   30,   28,    0,   24,   25,    0,   36,    0,   33,
   34,   11,    0,   39,    0,   38,   16,   35,    0,   40,
};
const short yydgoto[] =
	{                                       1,
   37,   45,    6,   20,    8,   11,   70,   21,    9,   13,
   53,   23,   24,   25,   26,   54,   27,   62,   47,   55,
   56,   71,   87,   57,
};
const short yysindex[] =
	{                                      0,
  -29,    0, -244,    0, -224,    0,    0,    0,    0,    0,
  -30, -235,  -33,    0,    0, -235, -106,    0, -218,    0,
    0,    0,  -87,    0,    0,    0,    0,    0,    0,  -88,
  -83, -119, -119,    0, -235, -232, -111, -213,    0,  -32,
    0,    0, -119, -119,  -75,  -74,    0,  -72, -216,    0,
 -251, -238,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -118,    0, -212,  -68,  -65, -117,  -31,  -32,   31,
    0,    0,    0,  -57,    0,    0, -119,    0, -200,    0,
    0,    0,  -31,    0,  -56,    0,    0,    0,  -31,    0,};
const short yyrindex[] =
	{                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -94,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -53,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -50,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,};
const short yygindex[] =
	{                                      0,
   -1,  -21,    0,    8,    0,    0,    0,    0,    0,  -16,
   -7,    0,    0,    0,    0,    5,    0,    0,    0,    0,
    0,    0,    0,    0,
};
#define YYTABLESIZE 240
const short yytable[] =
	{                                       4,
    4,    4,   15,    4,   44,   22,   73,   78,    7,   40,
   17,   46,   51,   50,   28,   39,   65,   66,   29,   67,
   30,   58,   59,   32,   33,   10,   34,   35,   36,   45,
   45,   16,   12,   48,   16,   38,   41,   49,   68,   69,
   30,   42,   31,   32,   33,   30,   34,   35,   36,   60,
   61,   16,   63,   64,   83,   85,   75,   74,   30,   76,
   80,   32,   33,    4,   34,   35,   36,   84,   88,   16,
   89,   46,   43,   81,    0,   86,    0,   82,    0,    0,
    0,   90,    0,    0,    0,    0,    0,    0,    0,   19,
   52,   79,    0,    5,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   77,    0,    0,    0,    0,
   43,   72,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    2,    0,    0,    0,
    0,    0,    0,    0,    3,    0,   18,   18,   18,   14,
};
const short yycheck[] =
	{                                      33,
   33,   33,   33,   33,  124,   13,  125,  125,    1,   26,
   12,   33,  124,  125,   16,   23,  268,  269,  125,  258,
  259,   43,   44,  262,  263,  270,  265,  266,  267,  124,
  125,  270,  257,   35,  270,  123,  125,  270,   55,   56,
  259,  125,  261,  262,  263,  259,  265,  266,  267,  125,
  125,  270,  125,  270,   71,   77,  125,  270,  259,  125,
   68,  262,  263,   33,  265,  266,  267,  125,  125,  270,
   87,  125,  123,   69,   -1,   83,   -1,   70,   -1,   -1,
   -1,   89,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,
  123,  123,   -1,  123,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  263,   -1,   -1,   -1,   -1,
  270,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  264,   -1,  270,  270,  270,  270,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 270
#if YYDEBUG
const char * const yyname[] =
	{
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,"'{'","'|'","'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"DEFINE","ELSE",
"END","ERROR","FINALLY","FOR","IF","INCLUDE","PRINTF","RENDER","TQFOREACH",
"UNSAFE","URLESCAPE","STRING",
};
const char * const yyrule[] =
	{"$accept : grammar",
"grammar :",
"grammar : grammar include",
"grammar : grammar verbatim",
"grammar : grammar block",
"grammar : grammar error",
"include : INCLUDE STRING",
"verbatim : '!' verbatim1 '!'",
"verbatim1 :",
"verbatim1 : verbatim1 STRING",
"verbatims :",
"verbatims : verbatims verbatim",
"raw : STRING",
"block : define body end",
"block : define body finally end",
"define : '{' DEFINE string '}'",
"body :",
"body : body verbatim",
"body : body raw",
"body : body special",
"special : '{' RENDER string '}'",
"special : printf",
"special : if body endif",
"special : loop",
"special : '{' string '|' UNSAFE '}'",
"special : '{' string '|' URLESCAPE '}'",
"special : '{' string '}'",
"$$1 :",
"printf : '{' PRINTF $$1 printfargs '}'",
"printfargs :",
"printfargs : printfargs STRING",
"if : '{' IF stringy '}'",
"endif : end",
"endif : else body end",
"endif : elsif body endif",
"elsif : '{' ELSE IF stringy '}'",
"else : '{' ELSE '}'",
"$$2 :",
"loop : '{' FOR stringy '}' $$2 body end",
"$$3 :",
"loop : '{' TQFOREACH STRING STRING STRING '}' $$3 body end",
"end : '{' END '}'",
"$$4 :",
"finally : '{' FINALLY '}' $$4 verbatims",
"string : STRING string",
"string : STRING",
"stringy : STRING",
"stringy : STRING stringy",
"stringy : '|' stringy",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
/* LINTUSED */
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
unsigned int yystacksize;
int yyparse(void);
#line 305 "parse.y"

struct keywords {
	const char	*k_name;
	int		 k_val;
};

int
yyerror(const char *fmt, ...)
{
	va_list	 ap;
	char	*msg;

	file->errors++;
	va_start(ap, fmt);
	if (vasprintf(&msg, fmt, ap) == -1)
		err(1, "yyerror vasprintf");
	va_end(ap);
	fprintf(stderr, "%s:%d: %s\n", file->name, yylval.lineno, msg);
	free(msg);
	return (0);
}

int
kw_cmp(const void *k, const void *e)
{
	return (strcmp(k, ((const struct keywords *)e)->k_name));
}

int
lookup(char *s)
{
	/* this has to be sorted always */
	static const struct keywords keywords[] = {
		{ "define",		DEFINE },
		{ "else",		ELSE },
		{ "end",		END },
		{ "finally",		FINALLY },
		{ "for",		FOR },
		{ "if",			IF },
		{ "include",		INCLUDE },
		{ "printf",		PRINTF },
		{ "render",		RENDER },
		{ "tailq-foreach",	TQFOREACH },
		{ "unsafe",		UNSAFE },
		{ "urlescape",		URLESCAPE },
	};
	const struct keywords	*p;

	p = bsearch(s, keywords, nitems(keywords), sizeof(keywords[0]),
	    kw_cmp);

	if (p)
		return (p->k_val);
	else
		return (STRING);
}

#define START_EXPAND	1
#define DONE_EXPAND	2

static int	expanding;

int
igetc(void)
{
	int	c;

	while (1) {
		if (file->ungetpos > 0)
			c = file->ungetbuf[--file->ungetpos];
		else
			c = getc(file->stream);

		if (c == START_EXPAND)
			expanding = 1;
		else if (c == DONE_EXPAND)
			expanding = 0;
		else
			break;
	}
	return (c);
}

int
lgetc(int quotec)
{
	int		c;

	if (quotec) {
		if ((c = igetc()) == EOF) {
			yyerror("reached end of filewhile parsing "
			    "quoted string");
			if (file == topfile || popfile() == EOF)
				return (EOF);
			return (quotec);
		}
		return (c);
	}

	c = igetc();
	if (c == '\t' || c == ' ') {
		/* Compress blanks to a sigle space. */
		do {
			c = getc(file->stream);
		} while (c == '\t'  || c == ' ');
		ungetc(c, file->stream);
		c = ' ';
	}

	if (c == EOF) {
		/*
		 * Fake EOL when hit EOF for the first time. This gets line
		 * count rigchtif last line included file is syntactically
		 * invalid and has no newline.
		 */
		if (file->eof_reached == 0) {
			file->eof_reached = 1;
			return ('\n');
		}
		while (c == EOF) {
			if (file == topfile || popfile() == EOF)
				return (EOF);
			c = igetc();
		}
	}
	return (c);
}

void
lungetc(int c)
{
	if (c == EOF)
		return;

	if (file->ungetpos >= file->ungetsize) {
		void *p = reallocarray(file->ungetbuf, file->ungetsize, 2);
		if (p == NULL)
			err(1, "reallocarray");
		file->ungetbuf = p;
		file->ungetsize *= 2;
	}
	file->ungetbuf[file->ungetpos++] = c;
}

int
findeol(void)
{
	int	c;

	/* skip to either EOF or the first real EOL */
	while (1) {
		c = lgetc(0);
		if (c == '\n') {
			file->lineno++;
			break;
		}
		if (c == EOF)
			break;
	}
	return (ERROR);
}

int
yylex(void)
{
	char		 buf[8096];
	char		*p = buf;
	int		 c;
	int		 token;
	int		 starting = 0;
	int		 ending = 0;

	if (!in_define && block == 0) {
		while ((c = lgetc(0)) != '{' && c != EOF) {
			if (c == '\n')
				file->lineno++;
		}

		if (c == EOF)
			return (0);

newblock:
		c = lgetc(0);
		if (c == '{' || c == '!') {
			if (c == '{')
				block = '}';
			else
				block = c;
			return (c);
		}
		if (c == '\n')
			file->lineno++;
	}

	while ((c = lgetc(0)) == ' ' || c == '\t' || c == '\n') {
		if (c == '\n')
			file->lineno++;
	}

	if (c == EOF) {
		yyerror("unterminated block");
		return (0);
	}

	yylval.lineno = file->lineno;

	if (block != 0 && c == block) {
		if ((c = lgetc(0)) == '}') {
			if (block == '!') {
				block = 0;
				return ('!');
			}
			block = 0;
			return ('}');
		}
		lungetc(c);
		c = block;
	}

	if (in_define && block == 0) {
		if (c == '{')
			goto newblock;

		do {
			if (starting) {
				if (c == '!' || c == '{') {
					lungetc(c);
					lungetc('{');
					break;
				}
				starting = 0;
				lungetc(c);
				c = '{';
			} else if (c == '{') {
				starting = 1;
				continue;
			}

			*p++ = c;
			if ((size_t)(p - buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && c != '\n');
		*p = '\0';
		if (c == EOF) {
			yyerror("unterminated block");
			return (0);
		}
		if (c == '\n')
			file->lineno++;
		if ((yylval.v.string = strdup(buf)) == NULL)
			err(1, "strdup");
		return (STRING);
	}

	if (block == '!') {
		do {
			if (ending) {
				if (c == '}') {
					lungetc(c);
					lungetc(block);
					break;
				}
				ending = 0;
				lungetc(c);
				c = block;
			} else if (c == '!') {
				ending = 1;
				continue;
			}

			*p++ = c;
			if ((size_t)(p - buf) >= sizeof(buf)) {
				yyerror("line too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && c != '\n');
		*p = '\0';

		if (c == EOF) {
			yyerror("unterminated block");
			return (0);
		}
		if (c == '\n')
			file->lineno++;

		if ((yylval.v.string = strdup(buf)) == NULL)
			err(1, "strdup");
		return (STRING);
	}

	if (c == '|')
		return (c);

	do {
		if (c == '|') {
			lungetc(c);
			break;
		}

		if (ending) {
			if (c == '}') {
				lungetc(c);
				lungetc('}');
				break;
			}
			ending = 0;
			lungetc(c);
			c = block;
		} else if (c == '}') {
			ending = 1;
			continue;
		}

		*p++ = c;
		if ((size_t)(p - buf) >= sizeof(buf)) {
			yyerror("string too long");
			return (findeol());
		}
	} while ((c = lgetc(0)) != EOF && !isspace((unsigned char)c));
	*p = '\0';

	if (c == EOF) {
		yyerror("unterminated block");
		return (0);
	}
	if (c ==  '\n')
		file->lineno++;
	if ((token = lookup(buf)) == STRING)
		if ((yylval.v.string = strdup(buf)) == NULL)
			err(1, "strdup");
	return (token);
}

struct file *
pushfile(const char *name, int secret)
{
	struct file	*nfile;

	if ((nfile = calloc(1, sizeof(*nfile))) == NULL)
		err(1, "calloc");
	if ((nfile->name = strdup(name)) == NULL)
		err(1, "strdup");
	if ((nfile->stream = fopen(nfile->name, "r")) == NULL) {
		warn("can't open %s", nfile->name);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	nfile->lineno = TAILQ_EMPTY(&files) ? 1 : 0;
	nfile->ungetsize = 16;
	nfile->ungetbuf = malloc(nfile->ungetsize);
	if (nfile->ungetbuf == NULL)
		err(1, "malloc");
	TAILQ_INSERT_TAIL(&files, nfile, entry);
	return (nfile);
}

int
popfile(void)
{
	struct file	*prev;

	if ((prev = TAILQ_PREV(file, files, entry)) != NULL)
		prev->errors += file->errors;

	TAILQ_REMOVE(&files, file, entry);
	fclose(file->stream);
	free(file->name);
	free(file->ungetbuf);
	free(file);
	file = prev;
	return (file ? 0 : EOF);
}

int
parse(const char *filename)
{
	if ((file = pushfile(filename, 0)) == 0)
		return (-1);
	topfile = file;

	yyparse();
	errors = file->errors;
	popfile();

	return (errors ? -1 : 0);
}

void
dbg(void)
{
	if (nodebug)
		return;

	if (yylval.lineno == lastline + 1) {
		lastline = yylval.lineno;
		return;
	}
	lastline = yylval.lineno;

	printf("#line %d ", yylval.lineno);
	printq(file->name);
	putchar('\n');
}

void
printq(const char *str)
{
	putchar('"');
	for (; *str; ++str) {
		if (*str == '"')
			putchar('\\');
		putchar(*str);
	}
	putchar('"');
}
#line 714 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    unsigned int newsize;
    long sslen;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    sslen = yyssp - yyss;
#ifdef SIZE_MAX
#define YY_SIZE_MAX SIZE_MAX
#else
#define YY_SIZE_MAX 0xffffffffU
#endif
    if (newsize && YY_SIZE_MAX / newsize < sizeof *newss)
        goto bail;
    newss = (short *)realloc(yyss, newsize * sizeof *newss);
    if (newss == NULL)
        goto bail;
    yyss = newss;
    yyssp = newss + sslen;
    if (newsize && YY_SIZE_MAX / newsize < sizeof *newvs)
        goto bail;
    newvs = (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs);
    if (newvs == NULL)
        goto bail;
    yyvs = newvs;
    yyvsp = newvs + sslen;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
bail:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return -1;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif /* YYDEBUG */

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yyvsp[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 5:
#line 99 "parse.y"
{ file->errors++; }
break;
case 6:
#line 102 "parse.y"
{
			struct file	*nfile;

			if ((nfile = pushfile(yyvsp[0].v.string, 0)) == NULL) {
				yyerror("failed to include file %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);

			file = nfile;
			lungetc('\n');
		}
break;
case 7:
#line 117 "parse.y"
{
			if (in_define) {
				/* TODO: check template status and exit in case */
			}
		}
break;
case 9:
#line 125 "parse.y"
{
			if (*yyvsp[0].v.string != '\0') {
				dbg();
				puts(yyvsp[0].v.string);
			}
			free(yyvsp[0].v.string);
		}
break;
case 12:
#line 138 "parse.y"
{
			dbg();
			printf("if ((tp_ret = tp->tp_puts(tp, ");
			printq(yyvsp[0].v.string);
			puts(")) == -1) goto err;");

			free(yyvsp[0].v.string);
		}
break;
case 13:
#line 148 "parse.y"
{
			puts("err:");
			puts("return tp_ret;");
			puts("}");
			in_define = 0;
		}
break;
case 14:
#line 154 "parse.y"
{
			puts("return tp_ret;");
			puts("}");
			in_define = 0;
		}
break;
case 15:
#line 161 "parse.y"
{
			in_define = 1;

			dbg();
			printf("int\n%s\n{\n", yyvsp[-1].v.string);
			puts("int tp_ret = 0;");

			free(yyvsp[-1].v.string);
		}
break;
case 20:
#line 178 "parse.y"
{
			dbg();
			printf("if ((tp_ret = %s) == -1) goto err;\n", yyvsp[-1].v.string);
			free(yyvsp[-1].v.string);
		}
break;
case 22:
#line 184 "parse.y"
{ puts("}"); }
break;
case 24:
#line 186 "parse.y"
{
			dbg();
			printf("if ((tp_ret = tp->tp_puts(tp, %s)) == -1)\n",
			    yyvsp[-3].v.string);
			puts("goto err;");
			free(yyvsp[-3].v.string);
		}
break;
case 25:
#line 193 "parse.y"
{
			dbg();
			printf("if ((tp_ret = tp_urlescape(tp, %s)) == -1)\n",
			    yyvsp[-3].v.string);
			puts("goto err;");
			free(yyvsp[-3].v.string);
		}
break;
case 26:
#line 200 "parse.y"
{
			dbg();
			printf("if ((tp_ret = tp->tp_escape(tp, %s)) == -1)\n",
			    yyvsp[-1].v.string);
			puts("goto err;");
			free(yyvsp[-1].v.string);
		}
break;
case 27:
#line 209 "parse.y"
{
			dbg();
			printf("if (asprintf(&tp->tp_tmp, ");
		}
break;
case 28:
#line 212 "parse.y"
{
			puts(") == -1)");
			puts("goto err;");
			puts("if ((tp_ret = tp->tp_escape(tp, tp->tp_tmp)) "
			    "== -1)");
			puts("goto err;");
			puts("free(tp->tp_tmp);");
			puts("tp->tp_tmp = NULL;");
		}
break;
case 30:
#line 224 "parse.y"
{
			printf(" %s", yyvsp[0].v.string);
			free(yyvsp[0].v.string);
		}
break;
case 31:
#line 230 "parse.y"
{
			dbg();
			printf("if (%s) {\n", yyvsp[-1].v.string);
			free(yyvsp[-1].v.string);
		}
break;
case 35:
#line 242 "parse.y"
{
			dbg();
			printf("} else if (%s) {\n", yyvsp[-1].v.string);
			free(yyvsp[-1].v.string);
		}
break;
case 36:
#line 249 "parse.y"
{
			dbg();
			puts("} else {");
		}
break;
case 37:
#line 255 "parse.y"
{
			printf("for (%s) {\n", yyvsp[-1].v.string);
			free(yyvsp[-1].v.string);
		}
break;
case 38:
#line 258 "parse.y"
{
			puts("}");
		}
break;
case 39:
#line 261 "parse.y"
{
			printf("TAILQ_FOREACH(%s, %s, %s) {\n",
			    yyvsp[-3].v.string, yyvsp[-2].v.string, yyvsp[-1].v.string);
			free(yyvsp[-3].v.string);
			free(yyvsp[-2].v.string);
			free(yyvsp[-1].v.string);
		}
break;
case 40:
#line 267 "parse.y"
{
			puts("}");
		}
break;
case 42:
#line 275 "parse.y"
{
			dbg();
			puts("err:");
		}
break;
case 44:
#line 281 "parse.y"
{
			if (asprintf(&yyval.v.string, "%s %s", yyvsp[-1].v.string, yyvsp[0].v.string) == -1)
				err(1, "asprintf");
			free(yyvsp[-1].v.string);
			free(yyvsp[0].v.string);
		}
break;
case 47:
#line 291 "parse.y"
{
			if (asprintf(&yyval.v.string, "%s %s", yyvsp[-1].v.string, yyvsp[0].v.string) == -1)
				err(1, "asprintf");
			free(yyvsp[-1].v.string);
			free(yyvsp[0].v.string);
		}
break;
case 48:
#line 297 "parse.y"
{
			if (asprintf(&yyval.v.string, "|%s", yyvsp[0].v.string) == -1)
				err(1, "asprintf");
			free(yyvsp[0].v.string);
		}
break;
#line 1137 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return (1);
yyaccept:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return (0);
}
